Last Comment Bug 21747 - Implement backend for cmd_copyImageContents
: Implement backend for cmd_copyImageContents
Status: RESOLVED FIXED
[Hixie-P0] [geekweb-P4]
: pp
Product: Core
Classification: Components
Component: Widget: Gtk (show other bugs)
: Trunk
: x86 Linux
: -- major with 29 votes (vote)
: mozilla1.9beta3
Assigned To: Michael Ventnor
:
Mentors:
: 56341 60834 71922 127201 130708 130938 164788 195572 206076 216857 221119 223170 229660 239742 (view as bug list)
Depends on: 9669 64313 518249
Blocks: 14835 135300 210043 234716
  Show dependency treegraph
 
Reported: 1999-12-14 15:03 PST by Eli Goldberg
Modified: 2012-12-04 06:53 PST (History)
70 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments
Patch (3.55 KB, patch)
2007-12-04 18:42 PST, Michael Ventnor
no flags Details | Diff | Review
Patch 2 (3.78 KB, patch)
2007-12-04 19:56 PST, Michael Ventnor
no flags Details | Diff | Review
Patch 2.1 (3.77 KB, patch)
2007-12-04 20:05 PST, Michael Ventnor
no flags Details | Diff | Review
Patch 3 (6.46 KB, patch)
2007-12-05 18:27 PST, Michael Ventnor
roc: review+
roc: superreview+
mbeltzner: approvalM10-
mbeltzner: approval1.9+
Details | Diff | Review

Description Eli Goldberg 1999-12-14 15:03:52 PST
* TITLE/SUMMARY
[4.x] Seamonkey lacks Copy Image functionality

* STEPS TO REPRODUCE
0) Launch Apprunner
1) View a page with an image, such as the http://slip/projects/marvin/copy-paste/
copy-img test case
2) Context-click on the image

* RESULT
 - What happened

The context menu lacks a "Copy Image" or "Copy this Image" menu item. (There is a
disabled "Copy" menu item, however.)

 - What was expected

Image copying functionality, as has been present in Navigator since 1995 (for Mac
OS, at least).

* REGRESSION

 - Occurs On
        Mac OS Apprunner (8.24.99 AM optimized build)

 - Doesn't Occur On
        Netscape Navigator 1.12 (1995 release for Mac OS)
        Netscape Communicator 4.7 (all platforms)
        Internet Explorer 4.01 (Mac OS)


* CONFIGURATIONS TESTED

- [Mac] Beige Power Mac G3 (266 MHz PowerPC 750), 96 MB RAM (VM on; 1 MB of VM
used), 1024x768 (Thousands of Colors), Mac OS 8.6

- [Win32] Vectra VL (233 MHz P2), 96 MB RAM, 800x600 (True Color), NT 4.0 SP5.

- [Linux] Vectra VL (266 MHz P2), 96 MB RAM. Red Hat Linux 6.0 (GNOME).
Comment 1 Eli Goldberg 1999-12-14 15:05:59 PST
[qa assigning to self.]
Comment 2 Akkana Peck 1999-12-14 15:22:59 PST
Marking this M15 at Pinkerton's suggestion.  The clipboard doesn't currently
support images, and it's not clear what out plans are for this feature.  (I'd
like to see us support image copy, too, and have no objection to implementing
the editor end of it ... please talk the Powers That Be into agreeing that it's
needed.)

I'm also removing the [4.x] from the summary since that makes it look like it's
a 4.x bug, and changing platform/OS to All.
Comment 3 Eli Goldberg 1999-12-20 15:53:59 PST
[Noted dependency on 9669.]
Comment 4 Eli Goldberg 1999-12-20 16:14:59 PST
[per suggestion from Akkana, pinged jar to find out if he'd know who the "Powers
that Be" would comprise.]
Comment 5 Jim Roskind 1999-12-20 19:48:59 PST
I'm not sure who the "powers that be" are... but I decided to add Chris Saito to
the cc list.  I would also expect that this bug (for better or worse) should
land over in Pinkerton's pile, but I'm not going to move it (presuming that
folks had a reason for akkana to be holding it).
If this is indeed a regression from 4.x, we need to be sure this issue is
highlighted to Netscape marketing for their signoff relative to a Netscape
product, before we abandon it to the hope that non-Netscape activity would
supply the functionality.
Comment 6 Mike Pinkerton (not reading bugmail) 1999-12-21 10:38:59 PST
i think the ability to do this on win32 might already be there (i think i saw
that rod had already written the code). sdagley has a bug/feature to do this on
MacOS. Dunno what we want to do about linux (ask pav).

akkana has this bug probably because of the xp stuff that would have to be done
to allow this...there is more than just support from the clipboard.
Comment 7 rubydoo123 2000-01-19 12:01:59 PST
moving this one out to m18 -- we need to figure out the specs on this before we
go any further
Comment 8 Eli Goldberg 2000-03-21 08:04:08 PST
Since the bug to implement the underlying architecture has been latered, would it 
be worth doing likewise with this bug?

Comment 9 Akkana Peck 2000-03-21 11:08:18 PST
Yep, unfortunately we can't add this in the front end if it isn't going to be
implemented in the backend.  Thanks for the alert, Eli.
Comment 10 Eli Goldberg 2000-03-21 14:31:11 PST
Sure.

Correspondingly, Simon has snatched 9669 from the brink of death and re-opened
it, so, I'll do likewise with this bug. (Okay, other than the part about
reassigning it to Simon. ;)
Comment 11 R.K.Aa. 2000-04-19 13:12:35 PDT
Currently (2000-041908 M16 linux) - ANY image that is clicked on is copied to
clipboard. Works like a dream - pasting them too, but i don't really need all
that copying going on. I hope this copy-feature will be moved to context menu
instead?
Comment 12 Peter Trudelle 2000-04-19 17:41:35 PDT
Sounds like another bug: clicking on an image blows away my clipboard.  Already
filed?
Comment 13 R.K.Aa. 2000-04-21 22:16:10 PDT
Strange you should mention it - yes, actually it is: bug 36809
Comment 14 Akkana Peck 2000-07-25 11:56:19 PDT
9669 has been futured again (surprise, surprise!) so I'll do likewise with this
dependant bug.  Sorry, all.
Comment 15 rubydoo123 2000-07-27 13:13:47 PDT
adding help wanted keyword
Comment 16 Akkana Peck 2000-10-24 16:09:27 PDT
Anthony is taking over Output.  Not clear what XPToolkit folks want to do about
image copies.
Comment 17 R.K.Aa. 2000-11-21 01:50:53 PST
*** Bug 60834 has been marked as a duplicate of this bug. ***
Comment 18 Matthew Paul Thomas 2000-12-16 08:06:05 PST
*** Bug 56341 has been marked as a duplicate of this bug. ***
Comment 19 Matthew Paul Thomas 2000-12-16 08:11:24 PST
[Copying stuff from bug 56341]

Comments from pinkerton@netscape.com:

Support for image copy is about as follows:
- get dcone to provide necessary api's on nsIImage (1 day)
- get editor team to hook up image copy to clipboard api's (2 days)
  -- probably just give the clipboard the nsIImage
- write clipboard code to go between nsIImage and native image data (2 days per
platform)
Comment 20 Paul Chen 2000-12-27 11:09:28 PST
nav triage team:

Not important for beta1, marking nsbeta1-
Comment 21 Peter Trudelle 2000-12-27 12:05:20 PST
This is a required embedding feature, and is already targetted for the next 
milestone, so all the nsbeta keyword stuff should be moot, and I'm removing it. 
Is there any Apps-specific work implied by this bug? If so, perhaps bug 56341 
should be reopened, and the differences clarified.  Also, if this work really 
depends on bug 9669, that will need be retargetted, and possibly reassigned. cc 
pchen,sfraser
Comment 22 Terri Preston 2000-12-27 12:12:47 PST
Changing qa contact as i am resposible for this area now
Comment 23 Mike Pinkerton (not reading bugmail) 2001-01-03 11:29:37 PST
there is gecko work that needs to be done here, once it is hooked up in the 
toolkit, which is why i was leaving the two bugs separated (one was owned by 
the ender team).

whatever.
Comment 24 Mike Pinkerton (not reading bugmail) 2001-01-22 17:14:07 PST
i've landed this for win32. mac and linux still need work here.
Comment 25 Mike Pinkerton (not reading bugmail) 2001-01-25 13:46:23 PST
just landed image->PICT code on macos. only unix is left, and for someone to
call them. pushing to pavlov for implementation on unix, anthonyd and I will
file other fe-specific bugs when the presShell functionality comes online.

removing 36866 as a dependency, since there's nothing about clipboard support in
that bug (only the menu text, which isn't my department).
Comment 26 Stuart Parmenter 2001-02-01 02:02:55 PST
future. no linux apps care about this what-so-ever
Comment 27 Peter Trudelle 2001-02-08 11:46:31 PST
Huh?  Gimp does this, so why should Linux be the only platform where we don't
support it? reassigning to dr, leaving future for now, as I hear there are no
plans to use this in the editor.  Would be good to estimate how much toolkit
work is involved.
Comment 28 Dan Rosen 2001-02-08 17:08:31 PST
trudelle: i don't know about pavlov's assessment... with respect to time
involved, it'd be 2-3 days to write the conversion code from our image data to
x's (and for all i know, tor may have written this code already), and minimal
work to hook up to the clipboard after that.

if mac and win32 can do it, unix ought to also... ->1.0.
Comment 29 Stuart Parmenter 2001-02-08 21:26:48 PST
gimp doesn't do it.  gimp only supports copying inside itself.
Comment 30 Peter Trudelle 2001-02-27 18:32:46 PST
An important distinction.  I think this should work on Linux, but I don't think
we can afford to be the first to do it.  adding helpwanted keyword.
Comment 31 Dan Rosen 2001-03-14 12:26:02 PST
just curious, how does this block embedding?
Comment 32 Peter Trudelle 2001-03-15 15:40:52 PST
It was required for Win32 embedding, but has morphed to Linux-only and shouldn't 
block any known clients now.
Comment 33 Dan Rosen 2001-03-15 16:42:14 PST
In that case, removing embed keyword and detaching from the tracking bug. Unless
I'm mistaken, this shouldn't be on Jud's radar.
Comment 34 Brian 'netdragon' Bober 2001-03-21 22:24:52 PST
*** Bug 71922 has been marked as a duplicate of this bug. ***
Comment 35 Brian 'netdragon' Bober 2001-03-21 22:29:11 PST
This is not just in Unix, Windows on build 2001031008 doesn't have this ability 
either. Pinkerton said he landed this for Windows, so I'm assuming the front-
end hasn't been done yet.
Comment 36 Mike Pinkerton (not reading bugmail) 2001-03-22 12:00:32 PST
right, win32 and mac backends are in, but anthonyd has the bug for the UI. this 
bug is for the linux backend.
Comment 37 Dan Rosen 2001-04-11 15:09:19 PDT
Patch I'm working on in bug 64313 has a nice place,
PresShell::DoCopyImageContents, to work from, which is called on
cmd_copyImageContents.

Unix image-copying backend still needs implementation, and all backends need to
be hooked up to this new method.
Comment 38 Dan Rosen 2001-05-08 13:47:52 PDT
->future, per trudelle
Comment 39 Dan Rosen 2001-09-05 16:59:32 PDT
[spam] dr@netscape.com's bugs subject to redistribution by chofmann. R!
Comment 40 Benoit 2001-11-07 03:51:41 PST
[Tested using the "official" win32 mozilla 0.9.5 (build 2001101117) on Windows 2000]

* Shouldn't platform/OS be marked to All (I still don't see any way to copy
images in Win32 for example, I can see a disabled 'copy' command in the popup
tough) ?
* Is there any bug for the frontend -> popup on images showing 'Copy image (to
clipboard)', maybe also in "Edit" when only the image is showed (when 'show
image' is chosen). At this moment the only thing it does is copying the image
location like "[http://www.mozilla.org/images/mozilla-banner.gif]", and even
this option is available only if the image is double-clicked.
* Why is this bug not marked as '4xp' ?
* Since it is really a major bug (several people i know don't like/use
mozilla/ns6 for this mean reason - "I can't copy an image to the clipboard") can
we have at least a target milestone? 
Comment 41 John Morrison 2002-01-29 17:53:15 PST
This should probably belong somewhere with trudelle's team.
Comment 42 Peter Trudelle 2002-01-29 22:59:02 PST
Not sure how critical this is for MachV, but if it is trivial, maybe someone can
find time.  cc tpringle for input.
Comment 43 Todd Pringle 2002-02-04 19:27:51 PST
Hmm.  Frankly what is more critical (not sure if it is related work) is the set
image as wallpaper option.  Press and user feedback indicate that this is
important functionality to people.
Comment 44 Peter Trudelle 2002-02-05 19:02:57 PST
I think that is completely unrelated.  This feature is described in the original
report above.
Comment 45 Peter Trudelle 2002-02-06 00:25:10 PST
->bryner
Comment 46 Brian 'netdragon' Bober 2002-02-18 05:06:11 PST
Todd: Is there a bug on the wallpaper? If not, create one and assign it to me. I
will fix it. Otherwise, do you know the bug #?
Comment 47 Todd Pringle 2002-02-18 13:42:13 PST
Brian, I think there is another bug filed on the set as wallpaper option, but
I'm not sure what the number is.  Joe Hewitt might know - ccing him.
Comment 48 Joe Hewitt (gone) 2002-02-18 14:00:29 PST
This is pretty darn easy to do on Windows, but other platforms would be
difficult I presume.  The BITMAP data and header structs can be retrieved pretty
easily, as you can see in the patch for Set As Wallpaper (bug 41526).  Copying
them into the clipboard should be a snap on windows, where the BITMAP structures
are natively supported.
Comment 49 Alfonso Martinez 2002-02-22 07:39:18 PST
*** Bug 127201 has been marked as a duplicate of this bug. ***
Comment 50 Charles Manske 2002-03-11 17:25:54 PST
I just received bug 110153 to supply UI for this feature.
But we don't need any new UI, right?
Using "copy" on an image should put both the current clipboard flavors as well as 
actual bits (CF_BITMAP in windows). This is how it works in Netscape 4.x
Comment 51 Benoit 2002-04-04 13:46:39 PST
"Copy" on an image is still not there in the new context menus (build
2002040403, win32). Copy is neither enabled in the Edit menu when choosing "View
Image".
Isn't that "UI" ?
Comment 52 Matthias Versen [:Matti] 2002-04-07 05:25:47 PDT
*** Bug 130938 has been marked as a duplicate of this bug. ***
Comment 53 Kyle Keiran 2002-04-16 20:05:45 PDT
Images also do not high-light / which means they can't be selected to be copied 
or printed.
Comment 54 Hixie (not reading bugmail) 2002-05-03 06:22:39 PDT
They don't highlight; that doesn't mean they can't be selected. They in fact are
selected, you just can't see that they are.
Comment 55 Peter Trudelle 2002-05-05 01:27:29 PDT
That's a defect in itself, selections should be clearly visible.
Comment 56 Matthew Paul Thomas 2002-07-31 09:16:44 PDT
... And it's a separate defect, namely bug 14835. Marking as dependent, since an
image shouldn't look selected if selecting it doesn't do anything.
Comment 57 Alfonso Martinez 2002-08-17 04:36:01 PDT
*** Bug 130708 has been marked as a duplicate of this bug. ***
Comment 58 Ere Maijala (slow) 2002-08-28 12:05:40 PDT
*** Bug 164788 has been marked as a duplicate of this bug. ***
Comment 59 Dan Houson 2002-09-08 03:13:06 PDT
I think the people at mozilla should wontfix this if there not going to fix it
rather than just leaving it 
Comment 60 Hixie (not reading bugmail) 2002-09-08 06:52:16 PDT
This will be fixed, _eventually_... All the quicker if someone offers a patch. :-)
Comment 61 Jesse Ruderman 2002-09-11 14:37:47 PDT
The UI for this feature is bug 135300, "context menus: add Copy Image per ui 
spec".  Hixie, did you mean to remove the dependency link between this bug and 
135300?  Because this bug is linux-only and backends already exist for other 
platforms?
Comment 62 Hixie (not reading bugmail) 2002-09-11 16:09:26 PDT
oops.
Comment 63 Daniel Wang 2003-03-04 20:23:59 PST
*** Bug 195572 has been marked as a duplicate of this bug. ***
Comment 64 Jo Hermans 2003-05-17 11:54:31 PDT
*** Bug 206076 has been marked as a duplicate of this bug. ***
Comment 65 Michael Perrin 2003-07-01 06:42:01 PDT
Yes I think that "Copy Image" is a very useful feature that lacks in Mozilla 1.4
. I think it would be great if there were "Copy Image" and "Copy Image Location"
(in order to have a short context menu, why not doing a submenu called "Menu"
and when you move the mouse over it, it appears two items at the right of Menu
with the two items mentioned above ?), even if I don't use Copy Image Location.
In Opera (7.11), there are the two options in the context menu.
A big context menu is somehow not very annoying.
Comment 66 Manoj 2003-08-06 12:32:16 PDT
Isn't this fixed as indicated in bug 64313?
Comment 67 Simon Fraser 2003-08-11 09:59:12 PDT
Nope, still needs fixing.
Comment 68 Alfonso Martinez 2003-08-21 02:15:11 PDT
*** Bug 216857 has been marked as a duplicate of this bug. ***
Comment 69 Henrik Gemal 2003-09-09 07:04:28 PDT
http://gratisdei.com/FB.htm
seems to have the copy image function
Comment 70 Daniel Küstner 2003-09-09 22:25:03 PDT
Since they write "Activates the inherent ability ..." this sounds like they just
enable the function. But this should not work on Linux, since there is no such
function (and that's what this bug is about).
Comment 71 Brian 'netdragon' Bober 2003-09-10 00:27:36 PDT
I assume by Linux, you mean Gtk and qt, for as far as I know, neither Linux nor
X have a clipboard. Would this also apply to all *nixes running Gtk or qt?
Comment 72 Daniel Küstner 2003-09-10 04:27:41 PDT
Brian: You are right, that Linux has no clipboard. 

But X has one and Mozilla is using it already for copying text. The X clipboard
is capable of other content types then just text. Clients even can negotiate the
content type of the copied data.

For more information on this see http://www.jwz.org/doc/x-cut-and-paste.html and
http://tronche.com/gui/x/icccm/sec-2.html
Comment 74 Matthias Versen [:Matti] 2003-09-15 04:06:03 PDT
*** Bug 219258 has been marked as a duplicate of this bug. ***
Comment 75 Bill Mason 2003-10-03 08:04:56 PDT
*** Bug 221119 has been marked as a duplicate of this bug. ***
Comment 76 Bill Mason 2003-10-21 20:55:54 PDT
*** Bug 223170 has been marked as a duplicate of this bug. ***
Comment 77 Jo Hermans 2003-12-29 10:07:12 PST
*** Bug 229660 has been marked as a duplicate of this bug. ***
Comment 78 Jo Hermans 2004-04-05 15:51:55 PDT
*** Bug 239742 has been marked as a duplicate of this bug. ***
Comment 79 R.K.Aa. 2004-04-30 11:25:10 PDT
*** Bug 242214 has been marked as a duplicate of this bug. ***
Comment 80 MechCommanderRei 2006-08-08 20:31:34 PDT
Am I correct in presuming this bug is the reason why, running Xubuntu 6.06 Dapper, I can't copy an image in Firefox 1.5.0.5 and paste it directly into the Gimp 2.2.11 or Krita 1.5?  (I've tried highlighting an image to copy it, and pasting it, but no dice.)

This is about *half* of my dissatisfaction with copy-paste in Linux, the other half being the lack of an Irfanview alternative that can *receive* pasted images.

And this bug hasn't been touched in TWO YEARS? D:

I have a sinking feeling that this isn't gonna be fixed until at least 3.0, if ever D:
Comment 81 Kathleen Brade 2006-08-09 13:17:41 PDT
MechCommanderRei (comment 80) wrote:
>Am I correct in presuming this bug is the reason why, running Xubuntu 6.06
>Dapper, I can't copy an image in Firefox 1.5.0.5 and paste it directly into the
>Gimp 2.2.11 or Krita 1.5?

Yes, you are correct. I'm not a Linux person but I have poked in the source code.  I'd guess that the relevant file is:
  http://lxr.mozilla.org/mozilla1.8/source/widget/src/gtk2/nsClipboard.cpp

In particular, the code for nsClipboard::GetData() and nsClipboard::SetData doesn't handle nsIImages (look for kUnicodeMime).  Probably some other code will need to be fixed too (such as nsClipboard::HasDataMatchingFlavors()).

Someone working on fixing Linux to handle images would need to do something similar to the code in widget/src/mac or widget/src/windows.

Then again, before I wrote a bunch of code, I'd ask vlad or pavlov if/when the move to Cairo will affect this (I recall seeing some Cairo #ifdefs in the Mac clipboard code but that was probably in the 3.0 / trunk version of these files).
Comment 82 Bart Heinsius 2007-09-06 14:30:44 PDT
How can I add priority to this bug? I have to do it so often, copy an image somewhere and paste it in an email. 
Now I have to resort to cumbersome saving it to a file from GIMP and then inserting an image in Thunderbird.
Running Ubuntu feisty fawn.
Comment 83 Ivan Garcia 2007-11-12 23:17:26 PST
I have the Ubuntu Gutsy.

This bug for something that I consider really important has not been fixed since 8 YEARS AGO. I really vote to give it a serious priority.
Comment 84 Jon Germany 2007-11-13 03:26:43 PST
Yes please add the "save image as" and "copy image" options to the right click context menu in the Linux version of firefox.  It's silly cos it's available on the Windows version.  I currently have to use Konqueror to copy or save any image from a web page.  This is in my opinion A PRIORITY. 
Comment 85 Ivan Garcia 2007-11-14 02:37:22 PST
Jon, the SAVE IMAGE AS is already in my Firefox 2.0, but the COPY IMAGE still missing. The Mozilla SeaMonkey web browser already has this context menu. Why not to port that source part into Firefox ??

I've also realized that the seaMonkey COPY IMAGE works pasting to OpenOffice Writer but not to GIMP for example.

it may help (for developing pourposes) use the ubuntu applet named GLIPPER which shows the clipboard value.
Comment 86 Ivan Garcia 2007-11-14 02:58:32 PST
By the way Konqueror's COPY IMAGE works great for pasting into GIMP and OPENOFFICE WRITER.

There is a CopyImage extension for Firefox < 1.9 here.

http://www.projectit.com/freestuff.html

Maybe this code can be ported to work with 2.0
Comment 87 chilinh nguyen 2007-12-03 23:05:18 PST
Any updates on this? Seeing how old this bug file is I'm guessing not... I think it's pretty silly as well to have to use Konqueror or Opera to copy and paste images from clipboard.
Comment 88 Michael Ventnor 2007-12-04 18:36:42 PST
Taking, I have a working patch. I've only been familiar with our clipboard code for a day, but I've managed to cook something up.
Comment 89 Michael Ventnor 2007-12-04 18:42:25 PST
Created attachment 291585 [details] [diff] [review]
Patch

This works, but I'm sure Roc can tell me ways to make this code better.
Comment 90 Michael Ventnor 2007-12-04 19:56:48 PST
Created attachment 291597 [details] [diff] [review]
Patch 2

More mime types and safer code.
Comment 91 Michael Ventnor 2007-12-04 20:05:05 PST
Created attachment 291600 [details] [diff] [review]
Patch 2.1

Yet another oversight on my part. Sigh, I really need to start proofreading my code.
Comment 92 Robert O'Callahan (:roc) (Exited; email my personal email if necessary) 2007-12-05 14:11:19 PST
+                GdkPixbuf* pixbuf = nsImageToPixbuf::ImageToPixbuf(image);

You need to check for failure here, right?

+                GtkClipboard *aClipboard = gtk_clipboard_get(GetSelectionAtom(aWhichClipboard));

maybe here too?

Does copy and paste of images within Gecko work? E.g. if I copy an image and paste into an HTML editor (e.g. GMail composer)?
Comment 93 Michael Ventnor 2007-12-05 18:27:01 PST
Created attachment 291805 [details] [diff] [review]
Patch 3

(In reply to comment #92)
> +                GdkPixbuf* pixbuf = nsImageToPixbuf::ImageToPixbuf(image);
> 
> You need to check for failure here, right?

Yeah, I should.

> +                GtkClipboard *aClipboard =
> gtk_clipboard_get(GetSelectionAtom(aWhichClipboard));
> 
> maybe here too?

No, because GetSelectionAtom can only return one of two clipboards (either Primary or Clipboard), both of which always exist on Linux. We don't do failure checks in any other place where this function is called.

> Does copy and paste of images within Gecko work? E.g. if I copy an image and
> paste into an HTML editor (e.g. GMail composer)?

I've figured it out now and yes, this patch supports pasting of images. Of course its not that useful for now with pasting images into editor being borked, but its not that much extra code anyway. I've verified that pasting actually works on the clipboard side because I pasted the url from the HTML code generated in editor into my URL bar and lo and behold was the copied image.
Comment 94 Michael Ventnor 2007-12-05 18:58:29 PST
Comment on attachment 291805 [details] [diff] [review]
Patch 3

This is the oldest open GTK bug ever, and something that even I have lamented going without ever since switching to Linux. We really should take this for Firefox 3 since its quite unfair that users of other platforms have enjoyed this functionality in Gecko for a long time now ;-)

The fact that this patch is under 10KB for the enormous benefit it provides should be something to consider.
Comment 95 Reed Loden [:reed] (use needinfo?) 2007-12-05 19:00:21 PST
Note that this will also fix Firefox bug 234716. Killing two bugs with one patch ftw!
Comment 96 Mike Beltzner [:beltzner, not reading bugmail] 2007-12-06 11:12:25 PST
Comment on attachment 291805 [details] [diff] [review]
Patch 3

a=drivers for when trunk opens after Fx3 Beta 2 freeze
Comment 97 Reed Loden [:reed] (use needinfo?) 2007-12-11 00:42:55 PST
Checking in browser/base/Makefile.in;
/cvsroot/mozilla/browser/base/Makefile.in,v  <--  Makefile.in
new revision: 1.21; previous revision: 1.20
done
Checking in widget/src/gtk2/nsClipboard.cpp;
/cvsroot/mozilla/widget/src/gtk2/nsClipboard.cpp,v  <--  nsClipboard.cpp
new revision: 1.30; previous revision: 1.29
done
Comment 98 Mark Smith (:mcs) 2007-12-11 11:46:47 PST
FYI, "Copy Image" worked for me using this morning's nightly trunk build (Gecko/2007121108) on a Fedora 6 system.  I was able to paste the image into gimp.

It is great that this has been fixed.  We can now support copying page images to the clipboard on Linux in our Page Saver Pro extension as well.
Comment 99 Boris Zbarsky [:bz] (Out June 25-July 6) 2008-01-03 23:53:30 PST
It looks like this bumped the minimal GTK2 version we rely on to 2.6.  Unfortunately, configure still checks for version 1.8.0.  The check in configure needs to be updated, or the use of gtk_clipboard_set_image needs to be conditioned on the gtk version...
Comment 100 jessn 2012-12-04 06:53:14 PST
What about the possibility to paste image data into the composer in bugzilla?

Note You need to log in before you can comment on or make changes to this bug.